<?php

App::uses('EvCheckoutAppController', 'EvCheckout.Controller');

class OrdersController extends EvCheckoutAppController {

	public function beforeFilter() {
		parent::beforeFilter();

		$this->Auth->allow(array('complete', 'cancel'));
	}

	public function complete() {
		if (CakePlugin::loaded('EvTransactions') && ! empty($this->request->query['transaction'])) {
			$this->TransactionsManager = $this->loadComponent('EvTransactions.Transactions');
			$this->OrderManager = $this->loadComponent('EvCheckout.OrderManager');

			if ($this->TransactionsManager->checkPayment()) {
				$orderId = $this->OrderManager->buildOrder($this->request->query['transaction']);

				// call hooks
				// add email to queue
				$this->view = 'EvCheckout./Fallbacks/Order/success';
				$pageId = Configure::read('EvCheckout.pageIds.success');
			} else {

				$this->view = 'EvCheckout./Fallbacks/Order/fail';
				$pageId = Configure::read('EvCheckout.pageIds.fail');
			}
		}

		if (empty($this->view)) {
			$this->view = 'EvCheckout./Fallbacks/Order/fail';
			$pageId = Configure::read('EvCheckout.pageIds.fail');
		}

		// check if we have a specific content page set
		// if so - set the template
		if (! empty($pageId)) {
			$pageData = $this->assignPage($pageId);

			if (! empty($pageData)) {
				if (! empty($orderId)) {
					$pageData['Page']['title'] = str_replace('ORDERID', $orderId, $pageData['Page']['title']);
					$pageData['Page']['body'] = str_replace('ORDERID', $orderId, $pageData['Page']['body']);
					$this->set('data', $pageData);
				}

				$this->view = $this->Tpl->getTemplate($pageData, 'Page');
			}
		}
	}

	public function cancel() {
		if (CakePlugin::loaded('EvTransactions') && ! empty($this->request->query['transaction'])) {
			$this->TransactionsManager = $this->loadComponent('EvTransactions.Transactions');

			$this->TransactionsManager->failTransaction(
				$this->request->query['transaction'],
				'The order was cancelled by the user'
			);
		}

		$this->view = 'EvCheckout./Fallbacks/Order/cancel';
		$pageId = Configure::read('EvCheckout.pageIds.cancel');

		// check if we have a specific content page set
		// if so - set the template
		if (! empty($pageId)) {
			$pageData = $this->assignPage($pageId);

			if (! empty($pageData)) {
				$this->view = $this->Tpl->getTemplate($pageData, 'Page');
			}
		}
	}
}
